// IgorBan.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "IGOR.h"
#include "IgorBan.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIgorBan

CIgorBan::CIgorBan()
{
	// C[WXg̍쐬
	CBitmap cbm;
	TRY
	{
		cbm.LoadBitmap(IDB_KOMA20);

		m_pIshiImg = new CImageList();

		m_pIshiImg->Create(BMPSX_ISHI,BMPSX_ISHI,ILC_COLOR8|ILC_MASK,4,1);
		m_pIshiImg->Add( &cbm, RGB(0,0,255) );

	}
	CATCH(CMemoryException, e)
	{
		AfxMessageBox( IDS_ERRBITMAP,MB_ICONSTOP );
		THROW_LAST();
	}
	CATCH(CResourceException, e)
	{
		AfxMessageBox( IDS_ERRBITMAP,MB_ICONSTOP );
		THROW_LAST();
	}
	END_CATCH
	cbm.DeleteObject();
	Init();
}

CIgorBan::~CIgorBan()
{
	PDELETE( m_pIshiImg );
}


void CIgorBan::Init()
{
	ZeroMemory( &m_ishi[0][0], sizeof( BYTE ) * BANSIZE_X * BANSIZE_X );
	m_pntLastPos.x = 100;
	m_pntLastPos.y = 100;
}

BEGIN_MESSAGE_MAP(CIgorBan, CStatic)
	//{{AFX_MSG_MAP(CIgorBan)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIgorBan bZ[W nh

void CIgorBan::OnPaint() 
{
	CStatic::OnPaint();
	
	// ̕`
	CDC*	pDC = GetDC();
	DrawIshi(pDC);
	ReleaseDC(pDC);
	// `pbZ[WƂ CStatic::OnPaint() ĂяoĂ͂܂
}

BOOL CIgorBan::Set(int x, int y, int n)
{
	if(!IsWindow(this->m_hWnd))
		return FALSE;
	if( (x>=0) && (x<=BANSIZE_X) &&
		(y>=0) && (y<=BANSIZE_Y) &&
		( (n==ISHI_NULL) || (n==ISHI_KURO) || (n==ISHI_SIRO))
	)
	{
		if(m_ishi[x][y] == n)
			return FALSE;

		m_ishi[x][y] = n;
		CRect rc( x * BMPSX_ISHI, y * BMPSY_ISHI,
					(x+1) * BMPSX_ISHI, (y+1) * BMPSY_ISHI );
		//RedrawWindow( &rc );
		InvalidateRect( &rc, TRUE );
		m_pntLastPos.x = x;
		m_pntLastPos.y = y;

		return TRUE;
	}
	return FALSE;
}

int CIgorBan::Get(int x, int y)
{
	if( (x>=0) && (x<=BANSIZE_X) &&
		(y>=0) && (y<=BANSIZE_Y) )
	{
		return m_ishi[x][y];
	}
	return -1;
}

void CIgorBan::DrawIshi(CDC* pDC)
{
	CRect	rcClip;
	int	nClip = pDC->GetClipBox( &rcClip );

	if( nClip == ERROR || nClip == NULLREGION )
		return;
	
	
	CPoint pnt;

	for( int xx = 0; xx < BANSIZE_X; xx++ )
	{
		for( int yy = 0; yy < BANSIZE_Y; yy++ )
		{
			if( m_ishi[xx][yy] != ISHI_NULL )
			{
				pnt.x = xx * BMPSX_ISHI;
				pnt.y = yy * BMPSY_ISHI;
				//if( rcClip.PtInRect( pnt ) )
					m_pIshiImg->Draw( pDC, Get(xx,yy) - 1, pnt, ILD_NORMAL );
			}
		}
	}
	
	// Ōɑł͓ʂɕ`
	int n = Get(m_pntLastPos.x,m_pntLastPos.y);
	
	if( (n>=ISHI_SIRO) && (n<=ISHI_KURO) )
	{
		pnt.x = m_pntLastPos.x * BMPSX_ISHI;
		pnt.y = m_pntLastPos.y * BMPSY_ISHI;
		CRect rc(0,0,19,19);

		if( rc.PtInRect( m_pntLastPos ) )
			m_pIshiImg->Draw( pDC, Get(m_pntLastPos.x,m_pntLastPos.y) + 1, pnt, ILD_NORMAL );
	}

}

BOOL CIgorBan::SetByWndPoint(int x, int y, int n)
{
	return Set( x/BMPSX_ISHI, y/BMPSY_ISHI, n );
}

int CIgorBan::GetByWndPoint(int x, int y)
{
	return Get( x/BMPSX_ISHI, y/BMPSY_ISHI );
}

void CIgorBan::GetIshiCount(int* nW, int* nB)
{
	*nW = 0;
	*nB = 0;
	for( int xx = 0; xx < BANSIZE_X; xx++ )
	{
		for( int yy = 0; yy < BANSIZE_Y; yy++ )
		{
			switch( m_ishi[xx][yy] )
			{
			case ISHI_SIRO:
				(*nW)++;
				break;
			case ISHI_KURO:
				(*nB)++;
				break;
			default:
				break;
			}
		}
	}
}

void CIgorBan::SetIshiData(char * lpData)
{
	int nBanSize = (sizeof( BYTE ) * BANSIZE_X * BANSIZE_X);
	int nPointSize = sizeof( POINT );

	int nBufSize = nBanSize + nPointSize;
	
	memcpy( &m_ishi[0][0],	lpData,				nBanSize );
	memcpy( &m_pntLastPos,	lpData + nBanSize,	nPointSize );
}

int CIgorBan::GetIshiData(char * lpData)
{
	int nBanSize = (sizeof( BYTE ) * BANSIZE_X * BANSIZE_X);
	int nPointSize = sizeof( POINT );

	int nBufSize = nBanSize + nPointSize;

	// ܂NULLŌĂŕKvȃoCg𒲂ׂĂˁB
	if( lpData )
	{
		memcpy( lpData, &m_ishi[0][0], nBanSize );
		memcpy( lpData+nBanSize, &m_pntLastPos, nPointSize );
	}
	return nBufSize;
}

