// UdpSocket.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "IgorDlg.h"
#include "IgorBan.h"
#include "UdpSocket.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUdpSocket
CUdpSocket::CUdpSocket(CIGORDlg* pDlg)
{
	// ẽ|C^oϐɓ
	m_pDlg = pDlg;

	// j[NID𐶐
	// Mf[^󂯎Ȃl
	m_nUniID = GetTickCount();
}

//////////////////////////////////////////////////////////////////////////////
//
//	|[gԍŏ
//
//////////////////////////////////////////////////////////////////////////////
BOOL CUdpSocket::Init(  int nPortNo/*=2000*/, BOOL bDontRoute/*=TRUE*/ )
{
	// gpłUDP̍őlTCY₢킹
	unsigned short imud = ((CIGORApp*)AfxGetApp())->m_iMaxUdpDg;

	// 1024傫1024ɗ}
	m_iMaxUdpDg = ( imud > 1024 ? 1024 : imud );

	// \Pbg̏
	BOOL bOpBroadcast = TRUE;

	m_nPortNo = nPortNo;

	if(Create( nPortNo, SOCK_DGRAM ))
	{
		// \PbgIvV
		if(SetSockOpt( SO_BROADCAST, &bOpBroadcast, sizeof(BOOL) ) &&
			SetSockOpt( SO_DONTROUTE, &bDontRoute, sizeof(BOOL) ))
			return TRUE;
	}
	ErrorDump();
	return FALSE;
}

CUdpSocket::~CUdpSocket()
{
}


// ClassWizard KvƂȉ̍sҏWȂłB
#if 0
BEGIN_MESSAGE_MAP(CUdpSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CUdpSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CUdpSocket o֐

//////////////////////////////////////////////////////////////////////////////
//
//	f[^MĂ΂֐
//
//////////////////////////////////////////////////////////////////////////////
void CUdpSocket::OnReceive(int nErrorCode) 
{
	//-------------------------------------------
	// --- M ---
	//-------------------------------------------
	// UDP\Pbg̍ől
	int nBufSize = m_iMaxUdpDg;
	char* lpMsgBuf = new char[nBufSize+2];
	
	if( lpMsgBuf == NULL )	return;

	ZeroMemory( lpMsgBuf, nBufSize+2 );
	
	//-------------------------------------------
	// --- M ---
	//-------------------------------------------
	if( Receive(lpMsgBuf, nBufSize) < 1 )	// sock err
	{
		delete[] lpMsgBuf;
		return;
	}

	//-------------------------------------------
	// --- bZ[W̕ ---
	// MessageFormat͉L̗lɂȂĂ
	// |UserID|MSGID|񥥥|
	// | int  |int  |char     |
	//-------------------------------------------

	// UseID 4byte=sizeof(int)𒊏o
	DWORD nUserId = *((int*)lpMsgBuf);
	
	// u[hLXgȂ̂ŎMf[^󂯎Ă܂
	// ł͎Mf[^͎󂯎Ȃ
	if( m_nUniID != nUserId )
	{
		// MSGID 4byte=sizeof(int)𒊏o
		int nMsgId = *( (int*)(lpMsgBuf + sizeof(int)) );

		// bZ[W𒊏o(Ƃ͌Ȃ)
		char* lpMsg = lpMsgBuf + (sizeof(int)*2);

		// _CAOɒm点Ă
		m_pDlg->ProcessPendingRead(nMsgId, lpMsg);
	}
	delete[] lpMsgBuf;

	CAsyncSocket::OnReceive(nErrorCode);
}

//////////////////////////////////////////////////////////////////////////////
//
//	bZ[WM
//
//////////////////////////////////////////////////////////////////////////////
int CUdpSocket::SendMsg(int msgid, const void* lpBuf, int nBufLen)
{
	// netban message format
	// |UserID|MsgID|..string..|
	// | int  | int | strlen   |

	if( nBufLen + (sizeof(int)*2) > m_iMaxUdpDg )
		return -1;

	int nBufSize = nBufLen+(sizeof(int)*2)+2;
	char* lpMsgBuf = new char[nBufSize];
	
	if( lpMsgBuf == NULL )	return -1;

	ZeroMemory( lpMsgBuf, nBufSize );
	memcpy( lpMsgBuf,					&m_nUniID,	sizeof(DWORD));
	memcpy( lpMsgBuf + sizeof(int),		&msgid,		sizeof(int)	);
	memcpy( lpMsgBuf + (sizeof(int)*2),	lpBuf,		nBufLen		);

	int ret = CAsyncSocket::SendTo(lpMsgBuf, nBufSize, m_nPortNo);
	if( ret < 1 )
		ErrorDump();
	
	delete []lpMsgBuf;
	return ret;
}

//////////////////////////////////////////////////////////////////////////////
//
//	bZ[WM(I[o[Ch)
//
//////////////////////////////////////////////////////////////////////////////
int CUdpSocket::SendMsg(CString& str)
{
	// TODO:
	return SendMsg(MSG_STRING,str, str.GetLength());
}

//////////////////////////////////////////////////////////////////////////////
//
//	bZ[WM(I[o[Ch)
//
//////////////////////////////////////////////////////////////////////////////
int CUdpSocket::SendMsg(int nId)
{
	// TODO:
	return SendMsg(nId,_T(""),0 );
}

//////////////////////////////////////////////////////////////////////////////
//
//	bZ[WM(I[o[Ch)
//
//////////////////////////////////////////////////////////////////////////////
int CUdpSocket::SendMsg(int msgid, CString& str)
{
	return SendMsg(msgid, str, str.GetLength());
}

//////////////////////////////////////////////////////////////////////////////
//
//	fobOpG[ϊ֐
//
//////////////////////////////////////////////////////////////////////////////
void CUdpSocket::ErrorDump()
{
#ifdef _DEBUG
	switch( GetLastError() )
	{
	case WSANOTINITIALISED:
		afxDump<< "WSANOTINITIALISED";	
		break;
	case WSAENETDOWN:
		afxDump<<"WSAENETDOWN";			
		break;
	case WSAEADDRINUSE:
		afxDump<<"WSAEADDRINUSE";		
		break;
	case WSAEACCES:
		afxDump<<"WSAEACCES";		
		break;
	case WSAEINPROGRESS:
		afxDump<<"WSAEINPROGRESS";		
		break;
	case WSAEFAULT:
		afxDump<<"WSAEFAULT";			
		break;
	case WSAENOTSOCK:
		afxDump<<"WSAENOTSOCK";		
		break;
	case WSAENETRESET:
		afxDump<<"WSAENETRESET";		
		break;
	case WSAEAFNOSUPPORT:
		afxDump<<"WSAEAFNOSUPPORT";		
		break;
	case WSAEINVAL:
		afxDump<<"WSAEINVAL";			
		break;
	case WSAENOBUFS:
		afxDump<<"WSAENOBUFS";			
		break;
	case WSAEOPNOTSUPP:
		afxDump<<"WSAEOPNOTSUPP";			
		break;
	case WSAENOTCONN:
		afxDump<<"WSAENOTCONN";			
		break;
	default :
		afxDump << "[" << GetLastError() << "]";
		break;
	}
	afxDump << "\n";
#endif
}

